       function dli3(x)                            
C  ******************************************************************
C  *                                                                *
C  *                 program for calculations of                    *
C  *              trilogatithms and related functions               *
C  *                                                                *
C  *      functions: dli3(x)                                        *
C  *                 rli3(x)                                        *
C  *                 rs12(x)                                        *
C  *                 clausen3(phi)                                  *
C  *                 cl3(phi)                                       *
C  *                                                                *
C  *           F. Jegerlehner, Paul Scherrer Institute              *
C  *                                                                *
C  *                     Version: 25-OCT-1990                       *
C  *                                                                *
C  ******************************************************************
c double precision calculation of the real part of the trilogarithm
       implicit none
       real *8 zeta3,zeta2,null,one,two,half,qua,i3,i6,x,r
       real *8 dli3,rli3,rs12,ddilog,sparg,omx
       real *8 clo,cloy,clom
       common /polylog5/zeta3,zeta2,null,one,two,half,qua,i3,i6
       save   /polylog5/
       data zeta2,zeta3/1.644934066848226d0,1.20205690315959d0/
       data null,one,two,half,qua,i3,i6/0.d0,1.d0,2.d0,.5d0,.25d0
     &                   ,.3333333333333333d0,.1666666666666667d0/
       dli3=0.d0
       if (x.eq.one) then
         dli3=zeta3
       return
       endif
       r=dabs(x)
       if (r.le.half) then
          dli3=rli3(x)
          return
       else if (x.le.-two) then
          sparg=one/x 
          clo=dlog(-x)
          dli3=rli3(sparg)-i6*clo**3-zeta2*clo
          return
       else if (x.ge.two) then
          sparg=one/x 
          clo=dlog(x)
c imaginary part ignored
          dli3=rli3(sparg)-i6*clo**3+two*zeta2*clo
          return
       else if (x.lt.-one) then 
          sparg=one/(one-x)
          clo =dlog(-x)
          cloy=dlog(sparg)
          clom=dlog(one-sparg)
          dli3= rs12(sparg)-rli3(sparg)+clom*ddilog(sparg)
     &           +i6*cloy**3+half*cloy*clom*clo-zeta2*clo
          return
       else if (x.lt.-half) then
          omx =one-x 
          sparg=one-one/omx                            
          clo=dlog(omx)
          dli3= rs12(sparg)-rli3(sparg)-clo*ddilog(sparg)-i6*clo**3
          return
       else if (x.gt.one) then
          clo=dlog(x) 
          sparg=one-one/x 
c imaginary part ignored
          dli3=-rs12(sparg)+clo*ddilog(sparg)+i3*clo**3
     &           -half*clo**2*dlog(x-one)+zeta2*clo+zeta3
          return
       else if (x.gt.half) then 
          clo=dlog(x) 
          sparg=one-x                            
          dli3=-rs12(sparg)-clo*ddilog(sparg)
     &           -half*clo**2*dlog(sparg)+zeta2*clo+zeta3
          return
       endif
       end

      function rli3(x)
c function Li(3) for real arguments of modulus smaller than one
      implicit none
      real *8 one,zeta3,x,rli3,b,z
      integer ini
      dimension b(21)
      common /polylog6/one,zeta3,b,ini
      save   /polylog6/
      data ini/0/,one/1.d0/
      data zeta3/1.20205690315959d0/
      if (ini.eq.0) goto 2
 1    if (x.eq.one) then
         rli3=zeta3
      return
      endif
      z=-dlog(one-x)          
      rli3=z*(z*(z*(z*(z*(z*(z*(z*(z*(z*(z*(z*(z*(z*(z*(z*(z*(z*(z*(z*
     & (z*b(20)+b(19))+b(18))+b(17))+b(16))+b(15))+b(14))+b(13))
     & +b(12))+b(11))+b(10))+b( 9))+b( 8))+b( 7))+b( 6))+b( 5))+b( 4))
     & +b(3))+b(2))+b(1))+one)
      return
C Coefficients for Li3:
C       b(0) =   1.0d0
 2      b(1) = - 3.75d-01
        b(2) =   7.8703703703703703d-02
        b(3) = - 8.6805555555555555d-03
        b(4) =   1.2962962962962963d-04
        b(5) =   8.1018518518518519d-05
        b(6) = - 3.4193571608537595d-06
        b(7) = - 1.3286564625850340d-06
        b(8) =   8.6608717561098513d-08
        b(9) =   2.5260875955320400d-08
        b(10)= - 2.1446944683640648d-09
        b(11)= - 5.1401106220129789d-10
        b(12)=   5.2495821146008294d-11
        b(13)=   1.0887754406636318d-11
        b(14)= - 1.2779396094493695d-12
        b(15)= - 2.3698241773087452d-13
        b(16)=   3.1043578879654623d-14
        b(17)=   5.2617586299125061d-15
        b(18)= - 7.5384795499492654d-16
        b(19)= - 1.1862322577752285d-16
        b(20)=   1.8316979965491383d-17
        b(21)=   2.7068171031837350d-18
      ini=1
      goto 1
      end

      function rs12(x)
c function S(1,2) for real arguments of modulus smaller than one
      implicit none
      real *8 one,two,half,qua,i6,zeta3
      real *8 x,rs12,dlog,dfloat,b,z,z2,ir
      integer ini,i
      common /polylog7/one,two,half,qua,i6,zeta3,b,ini
      save   /polylog7/
      dimension b(10)
      data ini/0/,one,two,half,qua/1.d0,2.d0,.5d0,.25d0/
      data i6,zeta3/.1666666666666667d0,1.20205690315959d0/
      if (ini.eq.0) goto 2
 1    if (x.eq.one) then
      rs12=zeta3
      return
      endif
      z=-dlog(one-x)
      z2=z*z
      rs12=z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*b(10)+b(9))
     &  +b(8))+b(7))+b(6))+b(5))+b(4))+b(3))+b(2))+b(1))
     &  +half-z*i6)*half
      return
 2       b(1) =  2.7777777777777778d-02
         b(2) = -2.7777777777777778d-04
         b(3) =  4.7241118669690098d-06
         b(4) = -9.1857730746619635d-08
         b(5) =  1.8978869988970999d-09
         b(6) = -4.0647616451442255d-11
         b(7) =  8.9216910204564526d-13
         b(8) = -1.9939295860721076d-14
         b(9) =  4.5189800296199182d-16
         b(10)= -1.0356517612181247d-17
      do i=1,10
         ir=dfloat(i)
         b(i)=b(i)*(two*ir+one)/(two*ir+two)
      enddo
      ini=1
      goto 1
      end

      function clausen3(phi)
c Clausens integral for arbitrary real arguments ( defined as the
c real part of the complex trilogarithm (Li3) on the unit circle 
c z=exp(i*phi) )  (2pi-periodic,even)
      implicit none
      real *8 null,one,pi,zpi,zeta3
      real *8 phi,phiabs,cl3,clausen3
      common /polylog8/null,one,pi,zpi,zeta3
      save   /polylog8/
      data pi /3.141592653589793d0/,zpi /6.283185307179586d0/    
      data zeta3/1.20205690315959d0/
      data null,one/0.d0,1.d0/
      phi=dmod(phi,zpi)
      if (phi.gt.pi) phi=phi-zpi
      phiabs=dabs(phi)
      if (phi.eq.null) then 
         clausen3=zeta3
      else
         clausen3=cl3(phiabs)
      endif
      return
      end
         
      function cl3(phi)        
c Clausens integral of 3rd order for real arguments 0<phi<pi
      implicit none
      real *8 one,half,threequa,b,phi,z,z2,cl3,pi,pi2,zeta3
      integer ini
      dimension b(15)
      common /polylog9/one,half,threequa,pi,pi2,zeta3,b,ini
      save   /polylog9/
      data zeta3/1.20205690315959d0/
      data pi /3.141592653589793d0/,pi2 /1.570796326794897d0/    
      data ini/0/,one,half,threequa/1.0d0,.50d0,.75d0/
      if (ini.eq.0) goto 2
 1    z=phi
      z2=z*z
      if (phi.le.pi2) then 
      if (phi.eq.0d0) then
      cl3=zeta3
      return
      endif
      cl3=-z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2* b(10)+ b(9))
     &  + b(8))+ b(7))+ b(6))+ b(5))+ b(4))+ b(3))+ b(2))+ b(1))
     &  +threequa-half*dlog(dabs(z)))+zeta3
      else                                       
      cl3=-z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*(z2*
     & (z2*(z2* b(15)+ b(14))+ b(13))+ b(12))+ b(11))+ b(10))+ b(9))
     &  + b(8))+ b(7))+ b(6))+ b(5))+ b(4))+ b(3))+ b(2))+ b(1))
     &  +threequa-half*dlog(dabs(z)))+zeta3
      endif
      return
 2       b(1) =  3.4722222222222222E-03
         b(2) =  1.1574074074074074E-05
         b(3) =  9.8418997228521037E-08
         b(4) =  1.1482216343327454E-09
         b(5) =  1.5815724990809166E-11
         b(6) =  2.4195009792525152E-13
         b(7) =  3.9828977769894878E-15
         b(8) =  6.9233666183059291E-17
         b(9) =  1.2552722304499773E-18
         b(10)=  2.3537540027684652E-20
         b(11)=  4.5363989034586869E-22
         b(12)=  8.9451696703926431E-24
         b(13)=  1.7982840046954963E-25
         b(14)=  3.6754997647937384E-27
         b(15)=  7.6208079715647952E-29
      ini=1
      goto 1
      end
                                 
